-------------
--Main Menu--
-------------
local mainRes = [["main"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"320"
		"tall"		"90"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Main Menu"
		"sizable"		"0"
	}
	"admin"
	{
		"ControlName"		"Button"
		"fieldName"		"admin"
		"xpos"		"20"
		"ypos"		"40"
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Admin Menu"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"admin"
		"Default"		"0"
	}
	"client"
	{
		"ControlName"		"Button"
		"fieldName"		"client"
		"xpos"		"120"
		"ypos"		"40"
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Client Menu"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"client"
		"Default"		"0"
	}
	"maps"
	{
		"ControlName"		"Button"
		"fieldName"		"maps"
		"xpos"		"220"
		"ypos"		"40"
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Maps Menu"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"maps"
		"Default"		"0"
	}
}]]

local mainMenu

function ulx.showMainMenu()
	if mainMenu then mainMenu:SetVisible( true ) return end

	mainMenu = vgui.Create( "Frame" )
	mainMenu:SetName( "window" )

	local admin = vgui.Create( "Button", mainMenu, "admin" )
	admin:SetActionFunction( mainMenuCallback )

	local client = vgui.Create( "Button", mainMenu, "client" )
	client:SetActionFunction( mainMenuCallback )

	local maps = vgui.Create( "Button", mainMenu, "maps" )
	maps:SetActionFunction( mainMenuCallback )

	mainMenu:LoadControlsFromString( mainRes )
	mainMenu:SetKeyBoardInputEnabled( true )
	mainMenu:SetMouseInputEnabled( true )

	mainMenu:SetPos( ScrW()*0.4, ScrH()-100 )
	mainMenu:SetVisible( true )
end

function mainMenuCallback( panel, type, value )
	if value == "admin" then
		mainMenu:SetVisible( false )
		ulx.showAdminMenu()
	elseif value == "client" then
		mainMenu:SetVisible( false )
		ulx.showClientMenu()
	elseif value == "maps" then
		mainMenu:SetVisible( false )
		ulx.showMapsMenu()
	end
end


--------------
--Admin Menu--
--------------
local function rcvValues( um, updateFn )
	local values = {}

	for _, key in ipairs( ulx.adminmenu_values ) do
		values[ key ] = um:ReadShort()
	end

	updateFn( values )
end
-- No hook! We'll hook this later so we can tell it what to call for update.

local adminRes = [["admin"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"700"
		"tall"		"500"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Admin Menu"
		"sizable"		"0"
	}
	"divider"
	{
		"ControlName"		"Divider"
		"fieldName"		"divider"
		"xpos"		"180"
		"ypos"		"20"
		"wide"		"2"
		"tall"		"460"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
	"applylimits"
	{
		"ControlName"		"Button"
		"fieldName"		"applylimits"
		"xpos"		"385"
		"ypos"		"430"
		"zpos"		"290"
		"wide"		"100"
		"tall"		"40"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Apply"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"apply"
		"Default"		"0"
	}
]]

local buttons = {
{ var="sbox_allownpcs", off="Allow NPCs", on="Disallow NPCs" },
{ var="sbox_godmode", off="Enable Global Godmode", on="Disable Global Godmode" },
{ var="sbox_plpldamage", off="Disable PvP Damage", on="Enable PvP Damage" },
{ var="sbox_noclip", off="Enable Noclip", on="Disable Noclip" },
}

for mul, info in ipairs( buttons ) do
	adminRes = adminRes .. [[
	"]] .. info.var .. [["
	{
		"ControlName"		"Button"
		"fieldName"		"]] .. info.var .. [["
		"xpos"		"20"
		"ypos"		"]] .. 50 + (mul-1)*30 .. [["
		"zpos"		"290"
		"wide"		"150"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		""
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"]] .. info.var .. [["
		"Default"		"0"
	}
]]
end

local limits = {
{ name="props", max=256 },
{ name="ragdolls", max=32 },
{ name="npcs", max=32 },
{ name="balloons", max=64 },
{ name="wheels", max=64 },
{ name="lamps", max=32 },
{ name="buttons", max=64 },
{ name="dynamite", max=32 },
{ name="effects", max=128 },
{ name="emitters", max=32 },
{ name="hoverballs", max=64 },
{ name="sents", max=128 },
{ name="spawners", max=32 },
{ name="thrusters", max=64 },
{ name="turrets", max=32 },
{ name="vehicles", max=32 },
}

for mul, info in ipairs( limits ) do
	local name = info.name
	local mulx = math.floor( (mul-1) / 8 ) -- Make rows of 8
	local muly = math.fmod( mul-1, 8 )
	adminRes = adminRes .. [[
	"]] .. name .. [[lbl"
	{
		"ControlName"		"Label"
		"fieldName"		"]] .. name .. [[lbl"
		"xpos"		"]] .. 200 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 20 .. [["
		"wide"		"128"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Max ]] .. string.upper( name:sub( 1, 1 ) ) .. name:sub( 2 ) .. [[:"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
	}
	"]] .. name .. [[slider"
	{
		"ControlName"		"Slider"
		"fieldName"		"]] .. name .. [[slider"
		"xpos"		"]] .. 200 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 40 .. [["
		"wide"		"200"
		"tall"		"20"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
	"]] .. name .. [[num"
	{
		"ControlName"		"Label"
		"fieldName"		"]] .. name .. [[num"
		"xpos"		"]] .. 410 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 40 .. [["
		"wide"		"64"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		""
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
	}
]]
end

adminRes = adminRes .. "}"

local adminMenu

function ulx.showAdminMenu()
	if not ULib.isSandbox() then
		ULib.csay( LocalPlayer(), "Sorry, this menu is only available in a sandbox gamemode." )
		return
	end

	-- We COULD use this line if we weren't taking such a hackish approach with the checkboxes.
	-- if adminMenu then adminMenu:SetVisible( true ) return end
	if adminMenu then adminMenu:SetVisible( false ) end

	adminMenu = vgui.Create( "Frame" )
	adminMenu:SetName( "window" )

	local btns = {}
	local function button_route( panel, action, cvar )
		local value = math.fmod( btns[ cvar ].value + 1, 2 )
		ULib.redirect( LocalPlayer(), "ulx", _, string.format( "rcon %s %i\n", cvar, value ) ) -- Garry broke our best way to do this.
		btns[ cvar ].value = value
		
		local info
		for _, data in ipairs( buttons ) do
			if data.var == cvar then
				info = data
				break
			end
		end

		if value == 1 then
		       	btns[ cvar ].panel:SetText( info.on )
		else
		       	btns[ cvar ].panel:SetText( info.off )
		end
	end

	for _, info in ipairs( buttons ) do
		local button = vgui.Create( "Button", adminMenu, info.var )
		button:SetText( info.off )
		button:SetActionFunction( button_route )
		btns[ info.var ] = { panel=button, value=0 }
	end

	local sliders = {}
	for _, info in ipairs( limits ) do
		local name = info.name
		local cvar = "sbox_max" .. name
		local max = info.max
		local num = vgui.Create( "Label", adminMenu, name .. "num" )
		num:SetText( "0" )
		local slider = vgui.Create( "Slider", adminMenu, name .. "slider" )
		slider:PostMessage( "SetInteger", "b", "1" )
		slider:PostMessage( "SetLower", "f", "0" )
		slider:PostMessage( "SetHigher", "f", max )
		slider:SetActionFunction( function ( panel, action, value )
			sliders[ cvar ].new = value
			num:SetText( tostring( value ) )
		end )
		sliders[ cvar ] = { panel=slider, num=num, value=0, new=0, max=max } -- So we can reference it in our update
	end

	local button = vgui.Create( "Button", adminMenu, "applylimits" )
	button:SetActionFunction( function ()
		for cvar, _ in pairs( sliders ) do
			local value = sliders[ cvar ].new
			if value ~= sliders[ cvar ].value then
				ULib.redirect( LocalPlayer(), "ulx", _, string.format( "rcon %s %i\n", cvar, value ) ) -- Garry broke our best way to do this.
			       	sliders[ cvar ].num:SetText( value )
			       	sliders[ cvar ].value = value
			end
		end
	end )

	adminMenu:LoadControlsFromString( adminRes )
	adminMenu:SetKeyBoardInputEnabled( true )
	adminMenu:SetMouseInputEnabled( true )

	adminMenu:SetPos( ScrW()*0.3, ScrH()-500 )
	adminMenu:SetVisible( true )
	
	-- Update function...
	local function update( values )
		for cvar, value in pairs( values ) do
			if sliders[ cvar ] then -- This is a cvar
				local slider = sliders[ cvar ]
				slider.value = value
				slider.panel:PostMessage( "SetValue", "f", value )
				slider.panel:PostMessage( "SetHigher", "f", math.max( ( 2 * value ), slider.max ) )
				slider.num:SetText( value )
			else
				local info
				for _, data in ipairs( buttons ) do
					if data.var == cvar then
						info = data
						break
					end
				end

				if value ~= 0 then
					local btn = btns[ cvar ]
					btn.panel:SetText( info.on )
					btn.value = 1
				else
					local btn = btns[ cvar ]
					btn.panel:SetText( info.off )
					btn.value = 0
				end
			end
		end
	end

	usermessage.Hook( "ulx_menuvalues", rcvValues, update ) -- The hook will get our function and call it.
	LocalPlayer():ConCommand( "ulx_valueupdate\n" )
end












---------------
--Client Menu--
---------------
local clientRes = [["client"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"600"
		"tall"		"400"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Client Menu"
		"sizable"		"0"
	}
	"divider"
	{
		"ControlName"		"Divider"
		"fieldName"		"divider"
		"xpos"		"20"
		"ypos"		"200"
		"wide"		"560"
		"tall"		"2"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
]]

local actions = {
"slap",
"slay",
"sslay",
"ignite",
"kick",
"ban",
"jail",
"unjail",
"ragdoll",
"unragdoll",
"gimp",
"ungimp",
"mute",
"unmute",
"freeze",
"unfreeze",
"god",
"ungod",
"cloak",
"uncloak",
"spectate",
"bring",
"goto",
}

for mul, action in ipairs( actions ) do
	local mulx = math.floor( (mul-1) / 4 ) -- Make rows of 4
	local muly = math.fmod( mul-1, 4 )
	clientRes = clientRes .. [[
	"]] .. action .. [["
	{
		"ControlName"		"Button"
		"fieldName"		"]] .. action .. [["
		"xpos"		"]] .. 30 + mulx*90 .. [["
		"ypos"		"]] .. muly*40 + 220 .. [["
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"]] .. string.upper( action:sub( 1, 1 ) ) .. action:sub( 2 ) .. [["
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"]] .. action .. [["
		"Default"		"0"
	}
]]
end

clientRes = clientRes .. "}"

local clientMenu
local selectedPly

local function routeCommand( panel, type, command )
	if not selectedPly then return end
	ULib.redirect( LocalPlayer(), "ulx", _, string.format( "%s \"%s\"\n", command, selectedPly:Nick() ) ) -- Garry broke our best way to do this.
end

function ulx.showClientMenu()
	-- We COULD use this line if we weren't taking such a hackish approach.
	-- if clientMenu then clientMenu:SetVisible( true ) return end
	if clientMenu then clientMenu:SetVisible( false ) selectedPly = nil end

	clientMenu = vgui.Create( "Frame" )
	clientMenu:SetName( "window" )
	
	local clientRes = string.sub( string.Trim( clientRes ), 1, -2 ) -- Make a local copy, going to change it. Cut off the "}".
	
	local players = player.GetAll()
	local num = 0
	for _, player in ipairs( players ) do
		num = num + 1
		local mulx = math.floor( (num-1) / 8 ) -- Make rows of 8
		local muly = math.fmod( num-1, 8 )
		clientRes = clientRes .. [[
		"ply]] .. num .. [["
		{
			"ControlName"		"RadioButton"
			"fieldName"		"ply]] .. num .. [["
			"xpos"		"]] .. 20 + mulx*150 .. [["
			"ypos"		"]] .. muly*20 + 30 .. [["
			"wide"		"130"
			"tall"		"24"
			"autoResize"		"0"
			"pinCorner"		"0"
			"visible"		"1"
			"enabled"		"1"
			"tabPosition"		"0"
			"labelText"		"]] .. player:Nick() .. [["
			"textAlignment"		"west"
			"dulltext"		"0"
			"brighttext"		"0"
			"wrap"		"0"
			"Default"		"0"
			"SubTabPosition"		"0"
		}
	]]
		local radiobox = vgui.Create( "RadioButton", clientMenu, "ply" .. num )
		radiobox:SetActionFunction( function() selectedPly = player end )
	end
	clientRes = clientRes .. "}"
	
	for _, action in ipairs( actions ) do
		local button = vgui.Create( "Button", clientMenu, action )
		button:SetActionFunction( routeCommand )
	end


	clientMenu:LoadControlsFromString( clientRes )
	clientMenu:SetKeyBoardInputEnabled( true )
	clientMenu:SetMouseInputEnabled( true )

	clientMenu:SetPos( ScrW()*0.3, ScrH()-500 )
	clientMenu:SetVisible( true )
end


-------------
--Maps Menu--
-------------
local MAPSPANEL = {}

function MAPSPANEL:Init()
	self.help = vgui.Create( "Label", self )
	self.help:SetText( "Pick a map:" )

	self.btns = {}
	for id, map in ipairs( ulx.maps ) do
		self.btns[ id ] = vgui.Create( "URoundButton", self )
		self.btns[ id ]:SetCText( map )
		self.btns[ id ]:SetCallback( self.Flag, self )
	end

	self.btnClose = vgui.Create( "URoundButton", self )
	self.btnClose:SetCText( "Close" )
	self.btnClose:SetCallback( self.Flag, self )

	surface.CreateFont( "coolvetica", 20, 500, true, false, "ULXMapsMenuFont" )
end

function MAPSPANEL:Flag( event, text, bool )
	text = text:lower()

	if event == "click" then
		if text == "close" then
			self:SetVisible( false )
			gui.EnableScreenClicker( false )
		else
			LocalPlayer():ConCommand( "ulx map \"" .. text .. "\"\n" )
		end
	end
end

function MAPSPANEL:PerformLayout()
	self.help:SizeToContents()
	self.help:SetPos( (self:GetWide() - self.help:GetWide()) / 2, 10 )
	
	for mul, btn in ipairs( self.btns ) do
		btn:SetSize( 119, 20 )

		local mulx = math.floor( (mul-1) / 16 ) -- Make 14 rows
		local muly = math.fmod( mul-1, 16 )
		btn:SetPos( mulx * 124 + 10, muly * 25 + 30 )
	end
	
	self.btnClose:SetSize( 300, 40 )
	self.btnClose:SetPos( (self:GetWide() - self.btnClose:GetWide()) / 2, self:GetTall() - self.btnClose:GetTall() - 10 )
end

function MAPSPANEL:ApplySchemeSettings()
	self.help:SetFont( "ULXMapsMenuFont" )
	for _, btn in ipairs( self.btns ) do
		btn:SetCFont( "DefaultBold" )
		if btn:GetCText():len() > 18 then
			btn:SetCFont( "DefaultSmall" )
		end
	end
	self.btnClose:SetCFont( "ULXMapsMenuFont" )
end

vgui.Register( "ULXMapsMenu", MAPSPANEL, "URoundMenu" )

function ulx.showMapsMenu()
	if not ulx.MapsMenuPanel then
		local pan = vgui.Create( "ULXMapsMenu" )

		pan:SetSize( 640, 480 )
		pan:SetPos( (ScrW()-pan:GetWide()) / 2, (ScrH()-pan:GetTall()) / 2 )
		
		ulx.MapsMenuPanel = pan
	end
	ulx.MapsMenuPanel:SetVisible( true )

	gui.EnableScreenClicker( true )
end
usermessage.Hook( "SendMapsMenu", ulx.showMapsMenu )


--------
--MOTD--
--------
ulx.motdContent = ""

local HTML = {}

function HTML:StatusChanged( text )
end

function HTML:ProgressChanged( progress )
end

function HTML:FinishedURL( url )
end

function HTML:OpeningURL( url, target )
	if string.find( url, "http://" ) then -- Link
		self:OpenURL( url )
	end
end

vgui.Register( "ULXMotd", HTML, "HTML" )

local MOTDPANEL = {}

function MOTDPANEL:Init()
	self.HTML = vgui.Create( "ULXMotd", self )
	self.HTML:SetHTML( [[ Hey <b>What's Up Dood! This is the test!</b>
	<p><a href="lua://Command/More">Click Here For More</a> or
	<a href="lua://Command/Close">Click Here To Close The Window!</a>]] )

	self.btnClose = vgui.Create( "URoundButton", self )
	self.btnClose:SetCText( "Close" )
	self.btnClose:SetCallback( self.Flag, self )

	surface.CreateFont( "coolvetica", 20, 500, true, false, "ULXMotdMenuFont" )
end

function MOTDPANEL:Flag( event, text, bool )
	text = text:lower()

	if event == "click" then
		if text == "close" then
			self:SetVisible( false )
			gui.EnableScreenClicker( false )
		end
	end
end

function MOTDPANEL:PerformLayout()
	if ScrW() > 640 then -- Make it larger if we can.
		self:SetSize( ScrW()*0.9, ScrH()*0.9 )
	else
		self:SetSize( 640, 480 )
	end
	self:SetPos( (ScrW()-self:GetWide()) / 2, (ScrH()-self:GetTall()) / 2 )

	self.HTML:SetSize( self:GetWide() - 20, self:GetTall() - 70 )
	self.HTML:SetPos( 10, 10 )

	self.btnClose:SetSize( 100, 40 )
	self.btnClose:SetPos( (self:GetWide() - self.btnClose:GetWide()) / 2, self:GetTall() - self.btnClose:GetTall() - 10 )
end

function MOTDPANEL:ApplySchemeSettings()
	self.btnClose:SetCFont( "ULXMotdMenuFont" )
end

vgui.Register( "ULXMotdMenu", MOTDPANEL, "URoundMenu" )

function ulx.showMotdMenu()
	if not ulx.MotdMenuPanel then
		local pan = vgui.Create( "ULXMotdMenu" )
		ulx.MotdMenuPanel = pan
	end
	ulx.MotdMenuPanel:SetVisible( true )
	ulx.MotdMenuPanel.HTML:SetHTML( ulx.motdContent )

	gui.EnableScreenClicker( true )
end
usermessage.Hook( "SendMotdMenu", ulx.showMotdMenu )

function ulx.rcvMotdText( um )
	ulx.motdContent = ulx.motdContent .. um:ReadString()
end
usermessage.Hook( "ULXMotdText", ulx.rcvMotdText )