table.sort( ulx.help, function (a,b) -- Sort our help
	return (a.cmd < b.cmd)
end )

table.sort( ulx.convarhelp, function (a,b) -- Sort our help
	return (a.cmd < b.cmd)
end )

-- Load our configs
local function init()
	if not file.Exists( "../lua/ulx/configs/server.ini" ) then
		Msg( "[ULX] ERROR: The server.ini file is missing!\n" )
	else
		ULib.execFile( "../lua/ulx/configs/server.ini" )
	end
	
	-- Per gamemode config
	if file.Exists( "../lua/ulx/configs/gamemodes/" .. GAMEMODE.Name:lower() .. ".ini" ) then
		ULib.execFile( "../lua/ulx/configs/gamemodes/" .. GAMEMODE.Name:lower() .. ".ini" )
	end
	
	-- Per map config
	if file.Exists( "../lua/ulx/configs/maps/" .. game.GetMap() .. ".ini" ) then
		ULib.execFile( "../lua/ulx/configs/maps/" .. game.GetMap() .. ".ini" )
	end
	
	-- Load our banned users
	if file.Exists( "../cfg/banned_user.cfg" ) then
		ULib.execFile( "../cfg/banned_user.cfg" )
	end
	
	-- Load our alias file
	if file.Exists( "../cfg/ulx_aliases.cfg" ) then
		game.ConsoleCommand( "exec ulx_aliases.cfg\n" )
	end

	ulx.DoDoneCallbacks() -- We're done loading!
end
hook.Add( "Initialize", "ULXInitialize", init )