function ulx.cc_who( ply, command, argv, args )
	ULib.console( ply, "Userid   Name   Level   Immune" )
	local players = player.GetAll()
	for _, player in ipairs( players ) do
		local text = string.format( "%i      %s", player:EntIndex(), player:Nick() )
		if player:IsUserGroup( ULib.ACCESS_SUPERADMIN ) then
			text = text .. "   Superadmin"
		elseif player:IsUserGroup( ULib.ACCESS_ADMIN ) then
			text = text .. "   Admin"
		elseif player:IsUserGroup( ULib.ACCESS_OPERATOR ) then
			text = text .. "   Operator"
		else
			text = text .. "   Guest"
		end
		
		if player:IsUserGroup( ULib.ACCESS_IMMUNITY ) then
			text = text .. "   yes"
		else
			text = text .. "   no"
		end
		ULib.console( ply, text )
	end
end
ulx.concommand( "who", ulx.cc_who, "- Shows all connected players ids and access.", ULib.ACCESS_ALL )

function ulx.cc_psay( ply, command, argv, args )
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], true, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end
	
	if target == ply then
		ULib.tsay( ply, "Why are you talking to yourself?" )
		return
	end
	
	local str = args:gsub( "^%S+%s+(.*)$", "%1" ) -- Remove first arg
	local nick
	if ply:IsValid() then
		nick = ply:Nick()
	else
		nick = "(Console)"
	end
	
	local message = string.format( "%s to %s: %s", nick, target:Nick(), str )

	ULib.tsay( target, message )
	ULib.tsay( ply, message )

	if util.tobool( GetConVarNumber( "ulx_logChat" ) ) then
		ulx.logString( message )
	end
end
ulx.concommand( "psay", ulx.cc_psay, "<user> <text> - Sends a private message to the user.", ULib.ACCESS_ALL, "!p", true, ulx.ID_PLAYER_HELP )

function ulx.cc_asay( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	if ply:IsValid() then
		nick = ply:Nick()
	else
		nick = "(Console)"
	end
	
    local message = string.format( "%s to admins: %s", nick, args )
	local players = player.GetAll()
	for _, player in ipairs( players ) do
		if player:IsUserGroup( ULib.ACCESS_OPERATOR ) and player ~= ply then
			ULib.tsay( player, message )
		end
	end
	ULib.tsay( ply, message ) -- Make sure they get it too.
	if isDedicatedServer() then	Msg( message .. "\n" ) end

	if util.tobool( GetConVarNumber( "ulx_logChat" ) ) then
		ulx.logString( message )
	end
end
ulx.concommand( "asay", ulx.cc_asay, "<text> - Sends a message to currently connected admins.", ULib.ACCESS_ALL, "@", true, ulx.ID_HELP )

function ulx.cc_tsay( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	ULib.tsay( _, args )

	if util.tobool( GetConVarNumber( "ulx_logChat" ) ) then
		ulx.logString( "(tsay) " .. args )
	end
end
ulx.concommand( "tsay", ulx.cc_tsay, "<text> - Sends a message to everyone.", ULib.ACCESS_ADMIN, "@@", true, ulx.ID_HELP )

function ulx.cc_csay( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	ULib.csay( _, args )

	if util.tobool( GetConVarNumber( "ulx_logChat" ) ) then
		ulx.logString( "(csay) " .. args )
	end
end
ulx.concommand( "csay", ulx.cc_csay, "<text> - Sends a message to everyone in the middle of the screen.", ULib.ACCESS_ADMIN, "@@@", true, ulx.ID_HELP )

function ulx.cc_rcon( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end
	
	ulx.logServAct( ply, "#A ran rcon command: " .. args, true )	

	-- Check some aliases
	if args:find( "sv_cheats 1" ) then
		args = args:gsub( "sv_cheats 1", "cheatson" )
	elseif args:find( "sv_cheats 0" ) then
		args = args:gsub( "sv_cheats 0", "cheatsoff" )
	end

	game.ConsoleCommand( args .. "\n" )
end
ulx.concommand( "rcon", ulx.cc_rcon, "<command> - Send the specified command to the server console.", ULib.ACCESS_SUPERADMIN, "!rcon", true, ulx.ID_HELP )

function ulx.cc_luaRun( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	game.ConsoleCommand( "lua_run " .. args .. "\n" )
	ulx.logServAct( ply, "#A ran lua_run: " .. args, true )
end
ulx.concommand( "luarun", ulx.cc_luaRun, "<command> - Feeds the server a lua command.", ULib.ACCESS_SUPERADMIN, _, _, ulx.ID_HELP )

function ulx.cc_exec( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

        if file.Exists( "../cfg/" .. argv[ 1 ] ) or file.Exists( "../cfg/" .. argv[ 1 ] .. ".cfg" ) then
		game.ConsoleCommand( "exec " .. argv[ 1 ] .. "\n" )
		ulx.logServAct( ply, "#A executed " .. argv[ 1 ], true )
        else
        	ULib.tsay( ply, "That config does not exist!" )
        end
end
ulx.concommand( "exec", ulx.cc_exec, "<file> - Executes a file.", ULib.ACCESS_ADMIN, _, _, ulx.ID_HELP )

function ulx.cc_map( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local map = argv[ 1 ]
	if string.sub( map, -4 ) == ".bsp" then
		map = string.sub( map, 1, -5 ) -- Take off the .bsp
	end

        if file.Exists( "../maps/" .. map .. ".bsp" ) then
		game.ConsoleCommand( "changelevel " .. map .. "\n" )
		ulx.logServAct( ply, "#A changed map to " .. map )
        else
        	ULib.tsay( ply, "That map does not exist!" )
        end
end
ulx.concommand( "map", ulx.cc_map, "<map> - Changes the map.", ULib.ACCESS_ADMIN, "!map", _, ulx.ID_ORIGINAL, "mapComplete" )

function ulx.cc_kick( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	if argv[ 2 ] then
		ulx.logUserAct( ply, target, "#A kicked #T (" .. argv[ 2 ] .. ")" )
	else
		ulx.logUserAct( ply, target, "#A kicked #T" )
	end

	ULib.kick( target, argv[ 2 ] )
end
ulx.concommand( "kick", ulx.cc_kick, "<user> [<reason>] - Kicks a user with the given reason", ULib.ACCESS_ADMIN, "!kick", _, ulx.ID_PLAYER_HELP )

function ulx.cc_ban( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end
	
	local bantime = tonumber( argv[ 2 ] ) or 0

	local time = "for " .. bantime .. " minute(s)"
	if bantime == 0 then time = "permanently" end
	ulx.logUserAct( ply, target, "#A banned #T " .. time )

	ULib.kickban( target, bantime )
end
ulx.concommand( "ban", ulx.cc_ban, "<user> [<time>] - Bans a user for time, use 0 time for permaban", ULib.ACCESS_ADMIN, "!ban", _, ulx.ID_PLAYER_HELP )

function ulx.cc_spectate( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't spectate from dedicated server console.\n" )
		return
	end
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end
	
	if target == ply then
		ULib.tsay( ply, "You can't spectate yourself!" )
		return
	end

	local pos = ply:GetPos()
	local ang = ply:GetAngles()
	local uid = ply:UniqueID()
	local function unspectate( player, key )
		if ply ~= player then return end -- Not the person we want
		if player:UniqueID() ~= uid then hook.Remove( "KeyPress", "ulx_unspectate_" .. ply:EntIndex() ) return end -- Different person
		if key ~= IN_FORWARD and key ~= IN_BACK and key ~= IN_MOVELEFT and key ~= IN_MOVERIGHT then return end -- Not a key we're interested in

		player:Spawn() -- Get out of spectate
		player:SetPos( pos )
		player:SetAngles( ang )
		ulx.logUserAct( player, target, "#A stopped spectating #T", true )
		hook.Remove( "KeyPress", "ulx_unspectate_" .. ply:EntIndex() )
	end
	hook.Add( "KeyPress", "ulx_unspectate_" .. ply:EntIndex(), unspectate )

	ulx.logUserAct( ply, target, "#A began spectating #T", true )
	ply:Spectate( OBS_MODE_IN_EYE )
	ply:SpectateEntity( target )
	ply:StripWeapons()
	
	ULib.tsay( ply, "To get out of spectate, move forward." )
end
ulx.concommand( "spectate", ulx.cc_spectate, "<user> - Spectates specified user. Move forward to get out of this mode.", ULib.ACCESS_ADMIN, "!spectate", true, ulx.ID_PLAYER_HELP )

function ulx.cc_ent( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "Can't create entities from dedicated server console.\n" )
		return
	end
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local class = argv[ 1 ]
	table.remove( argv, 1 ) -- We already have the first now
	newEnt = ents.Create( class )

	local trace = ply:GetEyeTrace()
	local vector = trace.HitPos
	vector.z = vector.z + 20

	newEnt:SetPos( vector ) -- Note that the position can be overridden by the users's flags

	for i, v in ipairs( argv ) do -- Loop through them
		local key = string.sub( v, 1, string.find( v, ":" ) - 1 )
		local value = string.sub( v, string.find( v, ":" ) + 1 )
		newEnt:SetKeyValue( key, value )
	end

	newEnt:Spawn()
	newEnt:Activate()

	ulx.logServAct( ply, "#A created ent \"" .. args .. "\"" )
end
ulx.concommand( "ent", ulx.cc_ent, "<classname> <flag>:<value> .. - spawn an ent, separate flag and value with : (IE: ulx ent prop_ragdoll model:models/alyx.mdl)", ULib.ACCESS_SUPERADMIN, _, _, ulx.ID_HELP )

function ulx.cc_cexec( ply, command, argv, args )
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	local cmd = string.gsub( args, "^%S+%s+(.*)$", "%1" )
	target:ConCommand( cmd )
	ulx.logUserAct( ply, target, "#A ran \"" .. cmd .. "\" on #T", true )
end
ulx.concommand( "cexec", ulx.cc_cexec, "<user(s)> <command> - Runs a command on the user's console.", ULib.ACCESS_SUPERADMIN, "!cexec", true, ulx.ID_PLAYER_HELP )

function ulx.cc_adduser( ply, command, argv, args )
	if #argv < 2 then
		if #argv ~= 0 then
			ULib.tsay( ply, ulx.LOW_ARGS )
		else
			ULib.console( ply, "ulx adduser <user> <group> [<immunity>]" )
			ULib.console( ply, "user - The user to add" )
			ULib.console( ply, "group - Choose \"operator\", \"admin\", or \"superadmin\"" )
			ULib.console( ply, "immunity - Should this player have immunity? Note that superadmins override other players' immunity." )
			ULib.console( ply, "This user WILL be added to the permanent users list!" )
			ULib.console( ply, "If the players's already added, it will clear their allow/deny list." )
			ULib.console( ply, "Operators have no default access. This makes them great for \"ulx userallow\"." )
		end
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	if target:IsUserGroup( ULib.ACCESS_SUPERADMIN ) and ply:IsValid() and not ply:IsListenServerHost() then
		ULib.tsay( ply, "Sorry, for security reasons, you can't change the access of a superadmin!" )
		return
	end

	local group = argv[ 2 ]
	local immunity = util.tobool( argv[ 3 ] )
	if (not ULib.ucl.groups[ group ] and not group == ULib.ACCESS_OPERATOR and not group == ULib.ACCESS_ADMIN and not group == ULib.ACCESS_SUPERADMIN) or group == "user" then
		ULib.tsay( ply, "Invalid group!" )
		return
	end

	local groups = { group }
	if immunity then table.insert( groups, ULib.ACCESS_IMMUNITY ) end
	
	local info = ULib.ucl.authed[ target ]
	if not info or info.type == "guest" then
		ULib.ucl.addUser( target:Nick(), "steamid", target:SteamID(), groups, {allow={}, deny={}} , _, _, true )
	else
		ULib.ucl.addUser( info.account, info.type, info.id, groups, {allow={}, deny={}} , _, _, true )
	end

	if immunity then
		ulx.logUserAct( ply, target, "#A added user #T to group \"" .. group .. "\" with immunity" )
	else
		ulx.logUserAct( ply, target, "#A added user #T to group \"" .. group .. "\"" )
	end
end
ulx.concommand( "adduser", ulx.cc_adduser, "<user> <group> [<immunity>] - Use with no args for more help.", ULib.ACCESS_SUPERADMIN, _, _, ulx.ID_PLAYER_HELP )

function ulx.cc_userallow( ply, command, argv, args )
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end
	
	if #argv > 2 then
		ULib.tsay( ply, "You specified too many arguments! Perhaps you forgot to put quotes around the allow command?" )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	if target:IsUserGroup( ULib.ACCESS_SUPERADMIN ) and ply:IsValid() and not ply:IsListenServerHost() then
		ULib.tsay( ply, "Sorry, for security reasons, you can't change the access of a superadmin!" )
		return
	end

	if not target:IsUserGroup( ULib.ACCESS_OPERATOR ) then
		ULib.tsay( ply, "Player must have at least operator access first!" )
		return
	end
	
	local info = ULib.ucl.authed[ target ]
	
	if not info then
		ULib.tsay( ply, "Player must be authenticated first!" )
		return
	end

	local allow = info.allow
	local deny = info.deny
	local command = argv[ 2 ]

	if not ULib.ucl.query( ply, command ) then
		ULib.tsay( ply, "You must first have access to this command in order to give it to others (or you can't give yourself access to commands)!" )
		return
	end

	for key, value in pairs( deny ) do
		if value == command then
			deny[ key ] = nil
		end
	end

	local key = 1
	while true do
		if not allow[ tostring( key ) ] then -- Found a slot
			allow[ tostring( key ) ] = command
			break -- Get out of infinite loop
		end
		key = key + 1
	end

	ULib.ucl.addUser( info.account, info.type, info.id, info.groups, {allow=allow, deny=deny} , info.pass, info.pass_req, true )

	ulx.logUserAct( ply, target, "#A granted #T access to the command \"" .. command .. "\"" )
end
ulx.concommand( "userallow", ulx.cc_userallow, "<user> <command> - Specifically allows the user access to command. (IE: \"ulx slap\")", ULib.ACCESS_SUPERADMIN, _, _, ulx.ID_PLAYER_HELP )

function ulx.cc_userdeny( ply, command, argv, args )
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end
	
	if #argv > 2 then
		ULib.tsay( ply, "You specified too many arguments! Perhaps you forgot to put quotes around the allow command?" )
		return
	end

	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	if target:IsUserGroup( ULib.ACCESS_SUPERADMIN ) and ply:IsValid() and not ply:IsListenServerHost() then
		ULib.tsay( ply, "Sorry, for security reasons, you can't change the access of a superadmin!" )
		return
	end

	if not target:IsUserGroup( ULib.ACCESS_OPERATOR ) then
		ULib.tsay( ply, "Player must have at least operator access first!" )
		return
	end
	
	local info = ULib.ucl.authed[ target ]
	
	if not info then
		ULib.tsay( ply, "Player must be authenticated first!" )
		return
	end

	local allow = info.allow
	local deny = info.deny
	local command = argv[ 2 ]

	if not ULib.ucl.query( ply, command ) then
		ULib.tsay( ply, "You must first have access to this command in order to deny it from others!" )
		return
	end

	for key, value in pairs( allow ) do
		if value == command then
			allow[ key ] = nil
		end
	end

	local key = 1
	while true do
		if not deny[ tostring( key ) ] then -- Found a slot
			deny[ tostring( key ) ] = command
			break -- Get out of infinite loop
		end
		key = key + 1
	end

	ULib.ucl.addUser( info.account, info.type, info.id, info.groups, {allow=allow, deny=deny} , info.pass, info.pass_req, true )

	ulx.logUserAct( ply, target, "#A denied #T access to the command \"" .. command .. "\"" )
end
ulx.concommand( "userdeny", ulx.cc_userdeny, "<user> <command> - Specifically denies the user access to command.", ULib.ACCESS_SUPERADMIN, _, _, ulx.ID_PLAYER_HELP )

function ulx.cc_thetime( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( os.date( "The time is now %I:%M %p.\n" ) )
	end
	ULib.tsay( _, os.date( "The time is now %I:%M %p." ) )
end
ulx.concommand( "thetime", ulx.cc_thetime, " - Shows you the server time.", ULib.ACCESS_ALL, "!thetime", _, ulx.ID_HELP )

function ulx.cc_menu( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't use menus from the dedicated server console.\n" )
		return
	end
	ULib.sendLuaFunction( ply, "ulx.showMainMenu" )
end
ulx.concommand( "menu", ulx.cc_menu, " - Shows you the main menu.", ULib.ACCESS_ALL, "!menu", _, ulx.ID_HELP )

function ulx.cc_adminmenu( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't use menus from the dedicated server console.\n" )
		return
	end
	
	if not ULib.ucl.query( ply, "ulx rcon" ) then
		ULib.tsay( ply, "You do not have access to this menu" )
		return
	end

	ULib.sendLuaFunction( ply, "ulx.showAdminMenu" )
end
ulx.concommand( "adminmenu", ulx.cc_adminmenu, " - Shows you the admin menu.", ULib.ACCESS_ADMIN, "!adminmenu", _, ulx.ID_HELP )

function ulx.cc_clientmenu( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't use menus from the dedicated server console.\n" )
		return
	end
	ULib.sendLuaFunction( ply, "ulx.showClientMenu" )
end
ulx.concommand( "clientmenu", ulx.cc_clientmenu, " - Shows you the client menu.", ULib.ACCESS_ADMIN, "!clientmenu", _, ulx.ID_HELP )

function ulx.cc_mapsmenu( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't use menus from the dedicated server console.\n" )
		return
	end

	if not ULib.ucl.query( ply, "ulx map" ) then
		ULib.tsay( ply, "You do not have access to this menu" )
		return
	end

	umsg.Start( "SendMapsMenu", ply )
	umsg.End()
end
ulx.concommand( "mapsmenu", ulx.cc_mapsmenu, " - Shows you the maps menu.", ULib.ACCESS_ADMIN, "!mapsmenu", _, ulx.ID_HELP )

function ulx.cc_motd( ply, command, argv, args )
	if not ply:IsValid() then
		Msg( "You can't see the motd from the console.\n" )
		return
	end

	if not file.Exists( "../" .. GetConVarString( "motdfile" ) ) then return end -- Invalid
	umsg.Start( "SendMotdMenu", ply )
	umsg.End()
end
ulx.concommand( "motd", ulx.cc_motd, " - Shows you the message of the day.", ULib.ACCESS_ALL, "!motd", _, ulx.ID_HELP )

local cadverts = { count=0 }
local tadverts = { count=0 }

function ulx.cc_addAdvert( ply, command, argv, args )
	if #argv < 2 then return end -- Invalid
	
	local message = argv[ 1 ] or ""
	local rpt = tonumber( argv[ 2 ] ) or 360
	local group = argv[ 3 ]

	message = string.gsub( message, "%%curmap%%", game.GetMap() )
	message = string.gsub( message, "%%host%%", GetConVarString( "hostname" ) )
	message = string.gsub( message, "%%ulx_version%%", string.format( "%.02f", ulx.version ) )
	
	tadverts.count = tadverts.count + 1

	if not group then
		timer.Create( "TSay" .. tadverts.count, rpt, 0, ULib.tsay, _, message )
	else
		if not tadverts[ group ] then
			tadverts[ group ] = { last=0 }
			local timerName = "TSay" .. tadverts.count
			local function doAdvert()
				local id = tadverts[ group ].last + 1
				tadverts[ group ].last = math.fmod( tadverts[ group ].last + 1, #tadverts[ group ] ) -- Reset the last

				ULib.tsay( _, tadverts[ group ][ id ].message )
				timer.Adjust( timerName, tadverts[ group ][ tadverts[ group ].last + 1 ].rpt, 0, doAdvert )
				timer.Start( timerName )
			end
			timer.Create( timerName, rpt, 0, doAdvert )
		end
		table.insert( tadverts[ group ], { rpt=rpt, message=message } )
	end
end
ulx.concommand( "addAdvert", ulx.cc_addAdvert, "", ULib.ACCESS_NONE ) -- Can only add from configs

function ulx.cc_addCsayAdvert( ply, command, argv, args )
	if #argv < 6 then return end -- Invalid

	local message = argv[ 1 ] or ""
	local r = tonumber( argv[ 2 ] ) or 255
	local g = tonumber( argv[ 3 ] ) or 255
	local b = tonumber( argv[ 4 ] ) or 255
	local rpt = tonumber( argv[ 5 ] ) or 300
	local len = tonumber( argv[ 6 ] ) or 10
	local group = argv[ 7 ]

	message = string.gsub( message, "%%curmap%%", game.GetMap() )
	message = string.gsub( message, "%%host%%", GetConVarString( "hostname" ) )
	message = string.gsub( message, "%%ulx_version%%", string.format( "%.02f", ulx.version ) )
	
	cadverts.count = cadverts.count + 1

	if not group then
		timer.Create( "CSay" .. cadverts.count, rpt, 0, ULib.csay, _, message, Color( r, g, b, 255 ), len )
	else
		if not cadverts[ group ] then
			cadverts[ group ] = { last=0 }
			local timerName = "CSay" .. cadverts.count
			local function doAdvert()
				local id = cadverts[ group ].last + 1
				cadverts[ group ].last = math.fmod( cadverts[ group ].last + 1, #cadverts[ group ] ) -- Reset the last

				ULib.csay( _, cadverts[ group ][ id ].message, cadverts[ group ][ id ].color, cadverts[ group ][ id ].len )
				timer.Adjust( timerName, cadverts[ group ][ cadverts[ group ].last + 1 ].rpt, 0, doAdvert )
				timer.Start( timerName )
			end
			timer.Create( timerName, rpt, 0, doAdvert )
		end
		table.insert( cadverts[ group ], { rpt=rpt, message=message, color=Color( r, g, b, 255 ), len=len } )
	end
end
ulx.concommand( "addCsayAdvert", ulx.cc_addCsayAdvert, "", ULib.ACCESS_NONE ) -- Can only add from configs

function ulx.cc_addForcedDownload( ply, command, argv, args )
	if #argv < 1 then return end -- Invalid

	if not file.Exists( "../" .. argv[ 1 ] ) then
		Msg( "ULX Config Error: Tried to add a nonexistant file to forced downloads '" .. argv[ 1 ] .. "'\n" )
		return
	end
	
	resource.AddFile( argv[ 1 ] )
end
ulx.concommand( "addForcedDownload", ulx.cc_addForcedDownload, "", ULib.ACCESS_NONE ) -- Can only add from configs

local function voteMapDone( t )
	local results = t.results
	local winner
	local winnernum = 0
	for id, numvotes in pairs( results ) do
		if numvotes > winnernum then
			winner = id
			winnernum = numvotes
		end
	end

	local str
	if not winner then
		str = "Vote results: No option won because no one voted!"
	else
		str = "Vote results: Option '" .. t.options[ winner ] .. "' won, changing levels! (" .. winnernum .. "/" .. t.voters .. ")"
	end
	ULib.tsay( _, str )
	ulx.logString( str )
	Msg( str .. "\n" )
	
	if winner then
		game.ConsoleCommand( "changelevel " .. t.options[ winner ] .. "\n" )
	end
end

function ulx.cc_votemap2( ply, command, argv, args )
	if #argv < 2 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end

	for id, map in ipairs( argv ) do
		if string.sub( map, -4 ) == ".bsp" then
			map = string.sub( map, 1, -5 ) -- Take off the .bsp
			argv[ id ] = map
		end

		if not file.Exists( "../maps/" .. map .. ".bsp" ) then
			ULib.tsay( ply, "Map " .. map .. " does not exist. Aborting command." )
			return
		end
	end

	ulx.doVote( "Change map to..", argv, voteMapDone )
	ulx.logServAct( ply, "#A started a votemap." )
end
ulx.concommand( "votemap2", ulx.cc_votemap2, "<map1> <map2> [<map3>] .. - Starts a public map vote", ULib.ACCESS_ADMIN, "!votemap2", _, ulx.ID_HELP )

local function voteKickDone( t, target )
	local results = t.results
	local winner
	local winnernum = 0
	for id, numvotes in pairs( results ) do
		if numvotes > winnernum then
			winner = id
			winnernum = numvotes
		end
	end

	local ratioNeeded = 0.5
	local str
	if winner ~= 1 or winnernum / t.voters < ratioNeeded then
		str = "Vote results: User will not be kicked. (" .. (results[ 1 ] or "0") .. "/" .. t.voters .. ")"
	else
		str = "Vote results: User will now be kicked. (" .. winnernum .. "/" .. t.voters .. ")"

	end
	ULib.tsay( _, str )
	ulx.logString( str )
	Msg( str .. "\n" )
	
	if winner == 1 and winnernum / t.voters >= ratioNeeded then
		ULib.kick( target, "Vote kick successful." )
	end
end

function ulx.cc_votekick( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end
	
	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	ulx.doVote( "Kick " .. target:Nick() .. "?", { "Yes", "No" }, voteKickDone, _, target )
	ulx.logUserAct( ply, target, "#A started a votekick against #T." )
end
ulx.concommand( "votekick", ulx.cc_votekick, "<user> - Starts a public kick vote", ULib.ACCESS_ADMIN, "!votekick", _, ulx.ID_PLAYER_HELP )

local function voteBanDone( t, target )
	local results = t.results
	local winner
	local winnernum = 0
	for id, numvotes in pairs( results ) do
		if numvotes > winnernum then
			winner = id
			winnernum = numvotes
		end
	end

	local ratioNeeded = 0.5
	local str
	if winner ~= 1 or winnernum / t.voters < ratioNeeded then
		str = "Vote results: User will not be banned. (" .. (results[ 1 ] or "0") .. "/" .. t.voters .. ")"
	else
		str = "Vote results: User will now be banned. (" .. winnernum .. "/" .. t.voters .. ")"

	end
	ULib.tsay( _, str )
	ulx.logString( str )
	Msg( str .. "\n" )
	
	if winner == 1 and winnernum / t.voters >= ratioNeeded then
		ULib.ban( target )
		ULib.kick( target, "Vote ban successful." )
	end
end

function ulx.cc_voteban( ply, command, argv, args )
	if #argv < 1 then
		ULib.tsay( ply, ulx.LOW_ARGS )
		return
	end
	
	local target, err = ULib.getUser( argv[ 1 ], _, ply )
	if not target then
		ULib.tsay( ply, err )
		return
	end

	ulx.doVote( "Ban " .. target:Nick() .. "?", { "Yes", "No" }, voteBanDone, _, target )
	ulx.logUserAct( ply, target, "#A started a voteban against #T." )
end
ulx.concommand( "voteban", ulx.cc_voteban, "<user> - Starts a public ban vote", ULib.ACCESS_ADMIN, "!voteban", _, ulx.ID_PLAYER_HELP )

--------------------
--     Hooks      --
--------------------
local function checkMinge( name )
	if util.tobool( GetConVarNumber( "ulx_mingekick" ) ) then
		if name == "MingeBag" or string.sub( name, 4 ) == "MingeBag" then -- Catches it with numbers in front as well
			game.ConsoleCommand( "kick \"" .. name .. "\"\n" )
			ULib.tsay( _, "[ULX] Auto-minge kick" )
		end
	end
end
hook.Add( "PlayerConnect", "ULXMingeCheck", checkMinge )
ulx.convar( "mingekick", "0", "<0/1> - Turns off/on auto-minge bag kick", ULib.ACCESS_ADMIN )

local function showWelcome( ply )
	local message = GetConVarString( "ulx_welcomemessage" )
	if not message or message == "" then return end

	message = string.gsub( message, "%%curmap%%", game.GetMap() )
	message = string.gsub( message, "%%host%%", GetConVarString( "hostname" ) )
	message = string.gsub( message, "%%ulx_version%%", string.format( "%.02f", ulx.version ) )

	ply:ChatPrint( message ) -- We're not using tsay because ULib might not be loaded yet. (client side)

	-- MOTD
	timer.Simple( 1, function() -- Give them time to fully spawn and load ULib
		if not file.Exists( "../" .. GetConVarString( "motdfile" ) ) then return end -- Invalid
		local f = file.Read( "../" .. GetConVarString( "motdfile" ) )

		if f:find( "You are playing Counter-Strike", 1, true ) and file.Exists( "../addons/ulx/motd.txt" ) then -- We want ULX to override the CSS motd
			f = file.Read( "../addons/ulx/motd.txt" )
		end
	
		while f:len() > 0 do
			umsg.Start( "ULXMotdText", ply )
				umsg.String( f:sub( 1, 240 ) )
			umsg.End()
			f = f:sub( 241 )
		end
	
		if util.tobool( GetConVarString( "ulx_showMotd" ) ) then
			umsg.Start( "SendMotdMenu", ply )
			umsg.End()
		end
	end )
end
hook.Add( "PlayerInitialSpawn", "ULXWelcome", showWelcome )
ulx.convar( "welcomemessage", "", "<msg> - This is shown to players on join", ULib.ACCESS_ADMIN )
ulx.convar( "showMotd", "1", " - Shows the motd to clients on startup.", ULib.ACCESS_ADMIN )

local function playerSay( ply )
	if not ply.lastChatTime then ply.lastChatTime = 0 end

	local chattime = GetConVarNumber( "ulx_chattime" )
	if chattime <= 0 then return end

	if ply.lastChatTime + chattime > CurTime() and not ply:IsAdmin() then
		return ""
	else
		ply.lastChatTime = CurTime()
		return
	end
end
hook.Add( "PlayerSay", "ulxPlayerSay", playerSay )
ulx.convar( "chattime", "1.5", "<time> - Players can only chat every x seconds (anti-spam). 0 to disable", ULib.ACCESS_ADMIN )

local function playerPickup( ply, ent )
	if ent:GetClass() == "player" and ULib.isSandbox() and ULib.ucl.query( ply, "ulx slap" ) and not ent.NoNoclip then
		if ply:IsUserGroup( ULib.ACCESS_SUPERADMIN ) or not ent:IsUserGroup( ULib.ACCESS_IMMUNITY ) then -- If player is superadmin or touched isn't immune
			ent:SetMoveType( MOVETYPE_NONE ) -- So they don't bounce
			return true
		end
	end
end
hook.Add( "PhysgunPickup", "ulxPlayerPickup", playerPickup ) -- Allow admins to move players

local function playerDrop( ply, ent )
	if ent:GetClass() == "player" then
		ent:SetMoveType( MOVETYPE_WALK )
	end
end
hook.Add( "PhysgunDrop", "ulxPlayerDrop", playerDrop )


------------------
-- Menu helpers --
------------------
local function valueUpdate( ply )
	if not ULib.ucl.query( ply, "ulx adminmenu" ) then -- No reason for them to get this.
		return
	end

	umsg.Start( "ulx_menuvalues", ply )
		for _, cvar in ipairs( ulx.adminmenu_values ) do
			umsg.Short( GetConVarNumber( cvar ) )
		end
	umsg.End()
end
ULib.concommand( "ulx_valueupdate", valueUpdate )